/*
Diese Klasse ermöglicht die Kommunikation mit dem Arduino
 -> senden einer '0': Kartenausgabe
 -> senden einer '1': Glockenklingeln
 */

public class Arduino {

  Serial arduino;
  char buffer;
  boolean read;

  Arduino(PApplet location) {
    //Verbindungen aufbauen
    println("> Versuche Verbindung zu Arduino aufzubauen ...");
    try {
      arduino = new Serial(location, Serial.list()[0], 9600);
      println("> Verbindung zum Arduino hergestellt.");
    } 
    catch (Exception excp) {
      System.err.println("! Keine Verbindung zum Arduino möglich (" + excp + ")");
    }
  }

  //Arduinoempfang starten
  void start() {
    read = true;
    this.listen();
  }

  //Arduino empfang stoppen
  void stop() {
    read = false;
  }

  //Daten an Arduino senden
  void send(char c) {
    arduino.write(c);
  }

  //Empfangen von Daten
  void listen() {
    while (arduino.available() > 0 && read) {
      //buffer = arduino.readChar();
      println(arduino.readChar());
    }
  }

  //Buffer auslesen
  int read() {
    if (read) {
      return buffer;
    } else {
      return -1;
    }
  }

  void check() {
    if (arduino.available() > 0) {
      println(arduino.readChar() + "\t" + frameCount);
    }
  }
}