class Box {
  int x;
  int y;
  int dx;
  int dy;
  Capture cam;

  //Variable für durchschnittsfrabe
  color theColor;
  //Farbreferenzen
  color[] colorReference;
  int[] colorThreshold;
  String[] colorName;
  
  //Konstruktor
  Box(int x, int y, int dx, int dy, Capture camera, String side) {
    this.x = x;
    this.y = y;
    this.dx = dx;
    this.dy = dy;
    this.cam = camera;
    
    
    //Festlegen von Referenzfarben
    if (side == "com") {
      colorReference = new color[] {#8e2d1f, #88965B, #7848a7};
      colorThreshold = new int[]{100, 60, 25};
      colorName = new String[] {"Rot", "Grün", "Lila"};
    } else {
      colorReference = new color[] {#cd5c5c, #7A8055, #58495A};
      colorThreshold = new int[]{80, 50, 80};
      colorName = new String[] {"Rot", "Grün", "Lila"};
    }
    //this.colorReference = loadReference("colorReference.json");
    //this.colorThreshold = loadThreshold("coloThreshold.json");
  }

  //Methode zum Anzeigen der Box
  void show() {
    median_color();
    noFill();
    rect(this.x, this.y, dx, dy);
    fill(255);
    text(getColor(), this.x, this.y+20);
  }

  //Berechnung der Durchschnittsfarbe der Box
  void avr_color() {
    float r = 0;
    float g = 0;
    float b = 0;
    for (int i = this.x; i < (this.dx + this.x); i++) {
      for (int j = this.y; j < (this.dy + this.y); j++) {
        int k = i + j * width;
        color pixel = cam.pixels[k];
        r += red(pixel);
        g += green(pixel);
        b += blue(pixel);
      }
    }

    r /= (dx*dy);
    g /= (dx*dy);
    b /= (dx*dy);

    //print(r + "\t" + r +"\t" + g +"\n");
    this.theColor = color(r, g, b);

    //Berechnete Durchschnittsfarbe in der Box anzeigen
    fill(this.theColor);
    rect(this.x, this.y, dx, (0.3*dy));
  }

  //Farbvergleich mit den Referenzwerten und zurückgabe von erkannter Frabe
  String getColor() {
    for (int i = 0; i < colorReference.length; i++) {
      float delta = dist(red(theColor), green(theColor), blue(theColor), red(colorReference[i]), green(colorReference[i]), blue(colorReference[i]));
      if (abs(delta) < colorThreshold[i]) {
        return colorName[i];
      }
    }
    return ("Null");
  }
  
  //Median-Farbe bestimmen und in "theColor" speichern
  void median_color() {
    int[] red = new int[this.dx*this.dy];
    int[] green = new int[this.dx*this.dy];
    int[] blue = new int[this.dx*this.dy];
    int m=0;

    for (int i = this.x; i < (this.dx + this.x); i++) {
      for (int j = this.y; j < (this.dy + this.y); j++) {
        int k = i + j * width;
        color pixel = cam.pixels[k];
        red[m] = (int)red(pixel);
        green[m] = (int)green(pixel);
        blue[m] = (int)blue(pixel);
        m++;
      }
    }

    red = sort(red);
    green = sort(green);
    blue = sort(blue);

    this.theColor = color((int)median(red), (int)median(green), (int)median(blue));
    
    //Berechnete Median-Farbe in der Box anzeigen
    fill(this.theColor);
    rect(this.x, this.y, dx, (0.3*dy));
  }

  //Median von einem Int-Array bilden und zurückgeben
  double median(int[] k) {
    double median;
    if (k.length % 2 == 0) {
      median = ((double)k[k.length/2] + (double)k[k.length/2 - 1])/2;
    } else {
      median = (double)k[k.length/2];
    }
    return median;
  }
  
  //toString Methode
  String toString() {
    return ("x: " + this.x + "\ty: " + this.y + "\tdx: " + this.dx + "\tdy: " + this.dy);
  }
}