/*
Hier wird das Hauptprogramm laufen, welches über die Klasse "Arduino" mit dem Arduino kommuniziert und
 mit der KLasse "Camera" die Kameradaten (und die Karteninformationen) ausliest.
 */

import processing.video.*;
import processing.serial.*;

Arduino arduino;
Camera camera;

void setup() {
  arduino = new Arduino(this);
  camera = new Camera(this);
}

void draw() {
  arduino.check();
  camera.update();

  //Anzahl der einzelnen Farbflächen zu sehen
  int[] k = camera.sum();
  for (int i = 0; i < k.length; i++) {
    text(k[i], 10, 15+10*i);
  }
}

//Testfunktion, um die Kartenausgabe und das Klingeln der Glock zu testen
void mousePressed() {
  if (mouseX > 0.5* width) {
    arduino.send('0');
  } else {
    arduino.send('1');
  }
}